/******************************************************************************
 *
 * MotionViewer
 * Copyright (C) 2007 Sangyoon Lee, Electronic Visualization Laboratory, 
 * University of Illinois at Chicago
 *
 * This software is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this software; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Questions or comments about MotionViewer should be directed to 
 * cavern@evl.uic.edu
 *
 *****************************************************************************/


#ifndef __MOCAPVISUALIZER_H__
#define __MOCAPVISUALIZER_H__

#include <vector>
#include <ogre.h>
using namespace Ogre;

class ViconVisualizer;
class ViconMotionDataSet;

// Visual Manager of all visual component
// have some common visual elements: grid, axis stuff
class MocapVisualizer
{
public:
	MocapVisualizer(SceneManager* mgr, SceneNode* head);
	~MocapVisualizer();
	
	void initVisualizer();

	void update(float addedTime);

protected:

	std::vector <ViconVisualizer*> m_vVisualizer;

	SceneManager*	m_pSceneMgr;
	SceneNode*		m_pBaseNode;
	ManualObject*	m_pGridObject;
	MaterialPtr		m_pGridMaterial;
	MaterialPtr		m_pRedMaterial;
	MaterialPtr		m_pGreenMaterial;
	MaterialPtr		m_pBlueMaterial;

};


#endif